import { EventBus, EventBusOptions, PublishOptions, SubscribeOptions } from '../../interfaces';
import { CloudEvent, EventType } from '../../types';
export declare class RabbitMQEventBus implements EventBus {
    private connection?;
    private channel?;
    private readonly options;
    private readonly MAX_RETRIES;
    private readonly RETRY_DELAYS;
    constructor(options: EventBusOptions);
    init(): Promise<void>;
    private setupDeadLetterHandling;
    private handleDeadLetter;
    private notifyDeadLetter;
    private incrementDeadLetterMetrics;
    publish<T>(event: CloudEvent<T>, options?: PublishOptions): Promise<void>;
    private handleMessage;
    subscribe<T>(type: EventType | EventType[], handler: (event: CloudEvent<T>) => Promise<void>, options?: SubscribeOptions): Promise<void>;
    private reconnect;
    private handleConnectionError;
    private handleConnectionClosed;
    private handleChannelError;
    private handleChannelClosed;
    unsubscribe(consumerTag: string): Promise<void>;
    close(): Promise<void>;
}
