"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConnectionHandler = void 0;
class ConnectionHandler {
    constructor(reconnect, recreateChannel) {
        this.reconnect = reconnect;
        this.recreateChannel = recreateChannel;
    }
    handleConnectionError(error) {
        return __awaiter(this, void 0, void 0, function* () {
            console.error("Connection error:", error);
            yield this.reconnect();
        });
    }
    handleConnectionClosed() {
        return __awaiter(this, void 0, void 0, function* () {
            console.warn("Connection closed, attempting to reconnect...");
            yield this.reconnect();
        });
    }
    handleChannelError(error) {
        return __awaiter(this, void 0, void 0, function* () {
            console.error("Channel error:", error);
            yield this.recreateChannel();
        });
    }
    handleChannelClosed() {
        return __awaiter(this, void 0, void 0, function* () {
            console.warn("Channel closed, attempting to recreate...");
            yield this.recreateChannel();
        });
    }
}
exports.ConnectionHandler = ConnectionHandler;
