import { Channel, ConsumeMessage } from "amqplib";
import { IdempotencyStore } from "../stores/indempotency";
import { CloudEvent } from "../../../types";
export declare class MessageHandler<E extends string = string> {
    private channel;
    private idempotencyStore;
    private options;
    private retryConfig;
    constructor(channel: Channel, idempotencyStore: IdempotencyStore, options: any, retryConfig: {
        maxRetries: number;
        delays: number[];
        retryExchange: string;
        deadLetterExchange: string;
    });
    private parseEvent;
    handleMessage<T>(msg: ConsumeMessage, handler: (event: CloudEvent<T, E>) => Promise<void>): Promise<void>;
    private handleRetryableError;
    private handleNonRetryableError;
}
