"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageStore = void 0;
const uuid_1 = require("uuid");
class MessageStore {
    constructor() {
        this.messages = new Map();
    }
    add(routingKey, content, options) {
        const messageId = options.messageId || (0, uuid_1.v4)();
        this.messages.set(messageId, { content, routingKey, options, timestamp: Date.now() });
    }
    getAll() {
        return Array.from(this.messages.values());
    }
    clear() {
        this.messages.clear();
    }
}
exports.MessageStore = MessageStore;
