"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EventFactory = void 0;
const uuid_1 = require("uuid");
class EventFactory {
    // NOTE: T, E extends string = string => E : that correspond to event type will be optional
    static create(type, data, source, options) {
        const metadata = {
            id: (options === null || options === void 0 ? void 0 : options.id) || (0, uuid_1.v4)(),
            time: (options === null || options === void 0 ? void 0 : options.time) || new Date().toISOString(),
            source,
            specversion: (options === null || options === void 0 ? void 0 : options.specversion) || "1.0",
            datacontenttype: (options === null || options === void 0 ? void 0 : options.datacontenttype) || "application/json",
            subject: options === null || options === void 0 ? void 0 : options.subject,
            correlationId: options === null || options === void 0 ? void 0 : options.correlationId
        };
        return {
            metadata,
            type,
            data
        };
    }
}
exports.EventFactory = EventFactory;
